import java.awt.*;
import java.applet.*;
import java.lang.*;


public class RectangleFun extends java.applet.Applet implements Runnable
{
    String      iStr;
    int         speed;
    boolean     wait;
    int         w, h;
    Graphics    MyGraphics;

    private Thread engine = null;


    //### Zustandsnderungen ###

    public void init()
    {
    	iStr = getParameter ("speed");
    	if (iStr != null)
    	    speed = Integer.parseInt (iStr);
    	else
    	    speed = 10;
    	if (speed == 0)
    	    speed = 1;

        Dimension d = size ();
        w = d.width;
        h = d.height;

        wait = false;

	}   //end init


    public void start()
    {
        if (engine == null)
	    {
    	    engine = new Thread(this);
    	    engine.start();
    	}
    }   //end start

    public void stop()
    {
        if (engine != null && engine.isAlive())
        {
	        engine.stop();
        }
        engine = null;
    }   //end stop

    public void destroy()
    {
    }   //end destroy


    //### Events ###

    public boolean handleEvent (Event e)
    {
        switch (e.id)
        {
            case Event.MOUSE_DOWN:
                if (wait)
                    wait = false;
                else
                    wait = true;
                return (true);

            case Event.WINDOW_MOVED:
                repaint ();
                return (true);

            default:
                return (false);
        }
    }


    //### Redraw ###

    public void paint (Graphics g)
    {
        MyGraphics = g.create ();
    }

    public void paint_ (Graphics g)
    {
        int rx, ry, rw, rh;

        rx  = Randomize (0, w - 1);
        ry  = Randomize (0, h - 1);
        rw  = Randomize (0, w - rx - 1);
        rh  = Randomize (0, h - ry - 1);
        Color col = new Color (Randomize (0, 255),
                Randomize (0, 255), Randomize (0, 255));

        g.setColor (col);
        // g.drawRect (rx, ry, rw, rh);
        g.fillRect (rx, ry, rw, rh);
    }


    //### Methoden ###

    public void run()
    {
        while (true)
        {
            if (!wait)
                // repaint ();
                paint_ (MyGraphics);
                // update (MyGraphics);
            try
            {
                Thread.sleep (speed);
            }
            catch (Exception e)
            {
            }
        }
    }

    public int Randomize (int min, int max)
    {
        return (min + (int) (Math.random () * (max - min)));
    }

}




